<?php
/*
 * @author Carlos Luis Sánchez Bocanegra
 * Basics file take all envolment elemento for our youtube videos.
 * It has all Constants definition
 *  #version 0.0.2
 *  #TODO
 *  Add __toString() methods
 */
/******************************************************************
 *  Libraries and inclusion variables                              *
 *****************************************************************/
// It must have gdata include on include_path on php_ini
require_once ("Zend/Loader.php");
// this define the init youtube feeds
define("GDATA","http://gdata.youtube.com/feeds/api/users/");
// Mode Debug on this app
define ("DEBUG",true);
// File to write through log debug
define ("DEBUG_FILE",'/etc/mhs/debugcrawler.log');
//Second part of GDATA -> GDATA+cHANNEL+START_INDEX
define("START_INDEX","/uploads?start-index=");
// How many videos on each page?
define ("MAXRESULT",50);
// Third part for GDATA
define("MAX_RESULTS","&max-results=".MAXRESULT."&v=2");
// For database use
define ("HOST","localhost");
define ("USER","er");
define ("PASS","hu3lvath0ms0");
define ("BBDD","er");
//valor creado para la tabla content_type_raredisease
// Si cambiamos a otro el raredisease deberáa modificarse al que corresponda
define ("NAMEMEDIA","raredisease");

//Configuration of drupal view on screen constants
define ("WIDTH",500);
define ("HEIGHT",400);
/***************************************************************************
 *  BASICS CLASSES AND METHODS
 **************************************************************************/
 /*
  * This Class give the time execution on a script
  * @param starttime by the time_start() method
  * @output time between a procedure/s using time_end() method
  * @ error nothing
  */
  class MeasureTime{
    private $starttime;
    function __construct(){
      $this->starttime = 0;
    }
    function time_start() {
      $mtime = microtime();
      $mtime = explode(" ",$mtime);
      $mtime = $mtime[1] + $mtime[0];
      $this->starttime = $mtime;
      if (DEBUG){
        error_log("[INFO-MeasureTime-time_start]Inicio de script a ".$this->starttime."\n",3,DEBUG_FILE);
      }
     }
     
    function time_end() {
      $mtime = microtime();
      $mtime = explode(" ",$mtime);
      $mtime = $mtime[1] + $mtime[0];
      return ($mtime - $this->starttime);
      if (DEBUG){
        debug_log ("[INFO-MeasureTime-time_end]Fin proceso: ".$mtime ."->". ($mtime - $this->starttime)."\n",3,DEBUG_FILE);
      }
    }
  }
  
  /*
   * This Class envolve one Chanel basics elements (IdChannet and ChanneID)
   * 
   * @params $idChannel as integer and $ChannelID as varchar for a Channel userid
   * 
   */
  class Channel{
    private $ChannelID;
    private $idChannel;
    
    public function __construct ($idChannel,$ChannelID){
      $this->ChannelID= $ChannelID;
      $this->idChannel=$idChannel;
      if (DEBUG){
        error_log("[Channel-construct]Canal Guardado con su valor ".$this->ChannelID.".\n",3,DEBUG_FILE);
      }
    }
    public function ChannelID(){
      return $this->ChannelID;
    }
    public function idChannel(){
      return $this->idChannel;
    }
  }
  
  
  /*
  * VideoEntry Class
  * This class envolve all properties necessary for one videoId
  * @ params......
  */
   class VideoEntry{
     private $videoid;
     private $canalID;
     private $title;
     private $description;
     private $categoria;
     private $tags;
     private $watchPage;
     private $flashPlayer;
     private $duration;
     private $viewcount;
     private $rating;
     private $geoLocation;

     

     public function __construct ($videoid, $videoTitle,
                      $videoDescription, $videoCategory,
                      $videoTags, $videoWatchPageUrl,
                      $flashPlayerUrl, $videoDuration,
                      $viewCount, $videoRatingInfo,
                      $videoGeoLocation, $canalID){                     
       $this->videoid = $videoid;
       $this->title = $videoTitle;
       $this->description = $videoDescription;
       $this->categoria = $videoCategory;
       $this->tags = $videoTags;
       $this->watchPage = $videoWatchPageUrl;
       $this->flashPlayer = $flashPlayerUrl;
       $this->duration = $videoDuration;
       $this->viewcount = $viewCount;
       $this->rating = $videoRatingInfo;
       $this->geLocation = $videoGeoLocation;
       $this->canalID = $canalID;
       
       if (DEBUG){
         error_log( "[INFO-VideoEntry-Contruct]Objeto VideoEntry creado".$this->__toString()."\n",3,DEBUG_FILE);
       }
     }
     public function videoid(){
       return $this->videoid;
     }
     public function title(){
       return $this->title;
     }
     public function description(){
       return $this->description;
     }
     public function categoria(){
       return $this-> categoria;
     }
     public function tags(){
       return $this->tags;
     }
     public function watchPage(){
       return $this->watchPage;
     }
     public function duration(){
       return $this->duration;
     }
     public function viewcount(){
       return $this->viewcount;
     }
     public function rating(){
       return $this->rating;
     }
     public function geoLocation(){
       return $this->geoLocation;
     }
     public function flashPlayer(){
       return $this->flashPlayer;
     }
     public function channelID(){
       return $this->canalID;
     }
     public function __toString(){
        return "Video:/n".$this->videoid." - ".$this->title." - ".$this->duration."\n";
     }
     public function getvideoRatingsLinks(){
       return $this->videoRatingsLinks;
     }
   }
   
   /*
    * Clase que gestiona básicamente el archivo log para que no crezca mucho
    * Básicamente guardo el último log, los anteriores se borrar
    * Borro el archivo
    * Creo uno limpio.
    */
   Class HealtVideoLog{
     public static function reset(){
       try{
         $fp = fopen(DEBUG_FILE, "w");
         fclose($fp);  
       }catch( Exception $e){
         echo ("EROOR limpiando log\n");
       }
     }
   }
?>
